#ifndef __QUEUE_H__
#define __QUEUE_H__

#include "transient.h"
#include "hasync.h"

struct haPage : haTransient {
    haPage* next;
    int     size;
    int     offs;
    char    body[1];
};
    
class haPageQueue { 
  public:
    haPage* get();
    void    put(int pageNo, int nPages, size_t offs, char* addr);
    void    free(haPage* pg);
    void    clear();
    void    stop();

    haPageQueue(size_t pgSize) { 
	pageSize = pgSize;
	sendListHead = sendListTail = freeList = NULL;
	stopped = false;
	waiting = false;
    }
    ~haPageQueue();

  private:
    haPage*  sendListHead;
    haPage*  sendListTail;
    haPage*  freeList;
    haMutex  mutex;
    haEvent  event;
    size_t   pageSize;
    bool     stopped;
    bool     waiting;
};

#endif
