#ifndef __SHMEM_H__
#define __SHMEM_H__

#include "hasync.h"
#include "haexcept.h"

struct haFileHeader { 
    char*  baseAddr;
    size_t usedSize;
};

class haSharedMemory { 
  public:
    void open(char const* fileName, size_t size, void* baseAddr);
    void close();
    
    size_t getPageSize() {
	return pageSize;
    }
    char*  base() { 
	return baseAddr;
    }
    size_t size() { 
	return fileSize;
    }

    void   writeProtect() { 
	setProtection(0, fileSize, false);
    }
    void   writeProtect(size_t offs) { 
	setProtection(offs, pageSize, false);
    }
    void   writeUnprotect(size_t offs) { 
	setProtection(offs, pageSize, true);
    }

    haSharedMemory();

  private:
    void   setProtection(size_t offs, size_t size, bool writeEnabled);

    size_t fileSize;
    size_t pageSize;
    char*  baseAddr;

#ifdef _WIN32
    HANDLE fd;
    HANDLE md;
#else
    int    fd;
#endif
};

#endif
